#pragma once
#include <string>
#include <map>

/**
	ˮ̬
*/
class CivDynamicCompute
{
public:
	typedef std::string String;
	typedef String& StringRef;
	typedef const StringRef  ConstStringRef;

	CivDynamicCompute();

	/**
	* @brief inpļ
	* @param [fileName]  inpļ
	* @return 򿪼inpļɹTrue򷵻False
	*/
	bool openFile(ConstStringRef fileName);

	/**
	* @brief ʼִˮʼ㣬һЩʼ
	*/
	bool beginCompute();

	/**
	* @brief ˮʼ㣬һЩ
	*/
	void endCompute();

	/**
	* @brief ȡĳĶĳʱε
	* @param [startTime] ʼʱ
	* @param [endTime] ʱ
	*/
	bool compute(int startTime, int endTime);

	/**
	* @brief ˮõתٱ
	* @param [pcode] ˮñʶ
	* @param [speeds] תٱֵ
	*/
	void updatePumpSpeed(ConstStringRef pcode, float speeds);

	/**
	* @brief Ҫµˮصˮ
	* @param [waterSources] ˮԴźˮ
	*/
	void updateQuality(const std::map<std::string, float>& waterSources);
	void setStartTime(const std::string& startTime) { mStartTime = startTime; }
	void setEndTime(const std::string& endTime) { mEndTime = endTime; }

	/**
	 *@brief ȡģ
	 * @param[resultMap] 洢ģĽ
	 */
	void simulResult(std::map<std::string, std::map<std::string, float>>& resultMap) const;
private:
	/**
	 * @brief ˮԴ
	 * @param [sourceType] ˮԴͣˮػˮ
	 * @param [pid] ˮԴı
	 * @param [density] Ũ
	 */
	void addWaterResiChlorine(const std::string& pid, float density);

	/**
	*@brief ʼˮʣнڵˮʳʼΪ0
	*/
	void resetQuality();

	/**
	* @brief ģ
	* @param Ҫĸʱε
	*/
	bool  saveResult(int iTime);

	/**
	*@brief ȡʱ
	*/
	std::string onTheHour(int iTime);
private:
	String mRptFile;
	String mBinFile;
	String mInpFile;
	int  mErrcode;

	std::string mStartTime;
	std::string mEndTime;

	// ˮģ
	std::map<std::string, std::map<std::string, float>> mSimulQualityMap; 

	// ˮˮ
	std::map<std::string, float> mWaterSourcesMap; // ˮ
};
